program oterleau;
{
Auteur: Franck PISSOTTE
http://www.pascaland.org/
http://franck.pissotte.free.fr/
Voici un programme d'othello datant des annees 1980.
j'avais realise une premiere version en basic suite a un article
paru dans un des tout premiers numeros de l'ordinateur individuel.
Vous n'aurez aucun probleme a battre ce programme car la stategie
se resume a prendre le plus grand nombre de pions possible.
}

uses
  crt;

const
  c_marqueur1='.'; 
  c_marqueur2='+'; 

type
  t_case = (vide,noir,blanc);                     { etat d'une case }
  t_jeu  = array[0..9,0..9] of t_case;            { le damier }
  t_joueur= noir..blanc;                          { les joueurs }
  direction=(sud,sud_est,est,nord_est,nord,nord_ouest,ouest,sud_ouest);
  dir_index=sud..sud_ouest;
  cot_index=1..8;
  t_mode=(auto,auto_noir,auto_blanc,manuel);

  string80=string[80];
  setofchar=set of char;

const
  dir_x:array[dir_index] of shortint=(0,1,1,1,0,-1,-1,-1);
  dir_y:array[dir_index] of shortint=(1,1,0,-1,-1,-1,0,1);
  car:array[t_case] of char=(' ','O','X');   { pions }
                            {' ',#1,#2}
  poids:array[cot_index,cot_index] of shortint=
            ( (16,  -4,  4,  2,  2,  4,  -4, 16),
              (-4, -12, -2, -2, -2, -2, -12, -4),
              ( 4,  -2,  4,  2,  2,  4,  -2,  4),
              ( 2,  -2,  2,  0,  0,  2,  -2,  2),
              ( 2,  -2,  2,  0,  0,  2,  -2,  2),
              ( 4,  -2,  4,  2,  2,  4,  -2,  4),
              (-4, -12, -2, -2, -2, -2, -12, -4),
              (16,  -4,  4,  2,  2,  4,  -4, 16) );
  milieu_partie=16;

var 
  jeu   :t_jeu;                       { le damier }
  score :array[t_case] of 0..64;      { le nombre de pions et de cases vides}
  joueur:t_joueur;                    { le joueur qui doit jouer }
  passe :0..2;                        { nombre de coup passes de suite }
  partie:array[1..60] of record       { coordonnees des coups joues }
                           li,co:cot_index; { coordonnes de la case }
                         end;

  changes:0..64;                      { le nombre de pions retournes }
  nb_coup:0..20;                      { nombre de coups possibles }
  coup_choisi:0..20;                  { indice du coup a jouer }
  numero:0..64;                       { numero du coup a jouer }
  ligne,colonne:cot_index;
  possible:array [1..20] of record             { liste des coups possibles }
                              li,co:cot_index; { coordonnes de la case }
                              pion:byte;       { gain du coup }
                            end;
  mode:t_mode;                        { mode de jeu }
  joue:boolean;

procedure affiche_jeu;
var 
  ligne,index:cot_index;
begin
  gotoxy(1,1);
  writeln('         OTHELLO VERSION 0.0');
  writeln;
  writeln('  A B C D E F G H');
  writeln(' Ŀ');
  for ligne:=1 to 8 do begin
    write(ligne,'');
    for colonne:=1 to 8 do write(car[jeu[colonne,ligne]],'');
    writeln;
    if ligne=8 then writeln(' ')
               else writeln(' Ĵ');
  end; {for}
end; {affiche_jeu}

procedure raz;
var 
  ligne,colonne:byte;
begin
  for ligne:=0 to 9 do jeu[0,ligne]:=vide;
  for colonne:=1 to 9 do jeu[colonne]:=jeu[0];
  jeu[4,5]:=noir;
  jeu[5,4]:=noir;
  jeu[4,4]:=blanc;
  jeu[5,5]:=blanc;
  score[noir]:=2;
  score[blanc]:=2;
  score[vide]:=60;
  changes:=0;
  joueur:=noir;
  mode:=auto_blanc;
  clrscr;
  affiche_jeu;
end; {raz}

procedure init;
var 
  i:byte;
begin
  numero:=1;
  partie[1].co:=5;
  partie[1].li:=5;
  for i:=2 to 60 do partie[i]:=partie[1];
  textmode(c40);
  raz;
end; {init}

function adversaire:t_joueur;
begin
  if joueur=noir then adversaire:=blanc
                 else adversaire:=noir;
end; {adversaire}

function calcule(c,l:byte):word;
var 
  s,n,x,y:word;
  d:direction;
begin
  s:=0;
  for d:=sud to sud_ouest do begin
    n:=0;
    x:=c;
    y:=l;
    repeat
      x:=x+dir_x[d];
      y:=y+dir_y[d];
      n:=n+1;
    until jeu[x,y]<>adversaire;
    if jeu[x,y]=joueur then begin
      n:=n-1;
      if n<>0 then if (d in [sud,nord]) and (c in [1,8]) then n:=n+10
        else if (d in [est,ouest]) and (l in [1,8])  then n:=n+10;
      S:=S+n;
    end; {if}
  end; {for}
  calcule:=s;
end; {calcule}

procedure cherche_coup;
var
  gain:word;
  ligne,index:cot_index;
begin
  nb_coup:=0;
  for ligne:=1 to 8 do begin
    for colonne:=1 to 8 do begin
      if jeu[colonne,ligne]=vide then begin
        gain:=calcule(colonne,ligne);
        if gain<>0 then begin
          nb_coup:=nb_coup+1;
          with possible[nb_coup] do begin
            li  :=ligne;
            co  :=colonne;
            pion:=gain;
          end; {with}
        end; {if}
      end; {if}
    end; {for}
  end; {for}
end; {cherche_coup}

procedure pose_pion(c,l:cot_index;ch:char);
begin
  gotoxy(3+(c-1)*2,5+(l-1)*2);
  write(ch,#8);
end; {pose_pion}

procedure retourne(c,l:byte);
var 
  n,k,x,y:word;
  d:direction;
begin
  changes:=0;
  for d:=sud to sud_ouest do begin
    n:=0;
    x:=c;
    y:=l;
    repeat
      x:=x+dir_x[d];
      y:=y+dir_y[d];
      n:=n+1;
    until jeu[x,y]<>adversaire;
    n:=n-1;
    if (jeu[x,y]=joueur) and (n>0) then begin
      changes:=changes+n;
      x:=c;
      y:=l;
      for k:=1 to n do begin
        x:=x+dir_x[d];
        y:=y+dir_y[d];
        jeu[x,y]:=joueur;
        pose_pion(x,y,car[joueur]);
      end; {for}
    end; {if}
  end; {for}
  jeu[c,l]:=joueur;
  pose_pion(c,l,car[joueur]);
  score[joueur]:=score[joueur]+changes+1;
  score[adversaire]:=score[adversaire]-changes;
  score[vide]:=score[vide]-1;
  partie[numero].li:=l;
  partie[numero].co:=c;
  numero:=numero+1;
end; {retourne}

procedure choisi_coup;
var 
  k,maxe,vale:integer;
begin
  maxe:=-maxint;
  for k:=1 to nb_coup do with possible[k] do begin
    if numero>milieu_partie then vale:=poids[co,li]+pion
                            else vale:=poids[co,li]-pion;
    if maxe<vale then begin
      maxe:=vale;
      ligne:=li;
      colonne:=co;
      coup_choisi:=k;
    end; {if}
  end; {with}
end; {choisi_coup}

procedure affiche_info;
var 
  c:t_case;
begin
  for c:=vide to blanc do begin
    gotoxy(20,3+ord(c));
    write(car[c],score[c]:3);
  end; {for}
  gotoxy(20,7);
  write('GAIN ',changes:2,' PIONS');
  gotoxy(20,8);
  write('A ',car[joueur],' de jouer');
  gotoxy(20,9);
  write('coup no ',numero);
end; {affiche_info}

function litcar(sc:setofchar):char;
var 
  ch:char;
begin
  repeat
    ch:=readkey;
    if ch=chr(0) then begin
      ch:=readkey;
      ch:=#0;
    end; {if}
    ch:=upcase(ch);
  until ch in sc;
  litcar:=ch;
end; {litcar}

procedure affiche(s:string80);
begin
  gotoxy(1,23);
  clreol;
  gotoxy(1,22);
  write(s);
  clreol;
end; {affiche}

procedure command;

  procedure indique_coup(n:integer;ch:char);
  begin
    with possible[n] do pose_pion(co,li,ch);
  end; {indique_coup}

procedure probleme;
var 
  buf:array[0..511] of byte;
  f:file;
  nom:string80;
  k,io:integer;
  com2:char;

  procedure lit_fich;
  begin
    affiche('Nom du fichier:');
    readln(nom);
    if pos('.',nom)=0 then nom:=nom+'.OTH';
  end; {lit_fich}

begin {probleme}
  joue:=false;
  for k:=1 to nb_coup do indique_coup(k,' ');
  repeat
    affiche('[Z]ero [S]auve [C]harge [M]odifie       [P]artie [F]in');
    com2:=litcar(['Z','S','C','M','F']);
    case com2 of
      'Z':begin init; affiche_info; end;
      'S':begin
            lit_fich;
            fillchar(buf,sizeof(buf),0);
            move(jeu,buf,
                 sizeof(jeu)+sizeof(score)+sizeof(joueur)+sizeof(passe)
                 (*+sizeof(partie)*));
            { $i-}
            assign(f,nom);
            rewrite(f,512);
            blockwrite(f,buf,1);
            close(f);
            { $i+}
          end;
      'C':begin
            lit_fich;
            {$i-}
            assign(f,nom);
            io:=ioresult;
            if io=0 then begin
              reset(f,512);
              io:=ioresult;
              if io=0 then begin
                blockread(f,buf,1);
                io:=ioresult;
              end {then};
              close(f);
            end; {if}
            {$i+}
            if io<>0 then begin
                affiche('Erreur de lecture. [enter] continuer');
                if litcar([#13])=#13 then ;
            end {if}
            else begin
              move(buf,jeu,
                   sizeof(jeu)+sizeof(score)+sizeof(joueur)+sizeof(passe)
                   (*+sizeof(partie)*));
              numero:=61-score[vide];
              changes:=0;
              affiche_jeu;
              affiche_info;
            end; {else}
          end;
      'M':;
      'P':;
    end; {case}
  until com2='F';
end; {probleme}

var 
  com1,com2:char;
  k,n:integer;
  fin:boolean;
begin {command}
  for k:=1 to nb_coup do indique_coup(k,c_marqueur1);
  if nb_coup<>0 then indique_coup(coup_choisi,c_marqueur2);
  repeat
    affiche('[M]ode [P]robleme [D]ernier [S]uivant   [+] [-] choisir [enter] jouer [F]in');
    com1:=litcar(['M','P','D','S','F','+','-',#13]);
    case com1 of
      'F':begin
            gotoxy(1,24);
            halt;
          end;
      'M':begin
            joue:=false;
            affiche('[A]uto [N]oir [B]lanc [M]anuel [F]in');
            com2:=litcar(['A','B','M','N','F']);
            case com2 of
              'A':mode:=auto;
              'B':mode:=auto_blanc;
              'N':mode:=auto_noir;
              'M':mode:=manuel;
            end; {case}
            for k:=1 to nb_coup do indique_coup(k,' ');
          end;
      'P':probleme;
      'D':begin
            if numero<>1 then begin
              n:=numero-1;
              raz;
              numero:=1;
              for k:=1 to n do retourne(partie[k].co,partie[k].li);
              joue:=false;
            end; {if}
          end;
      'S':begin
            if numero<>61 then begin
              with partie[numero] do begin
                if (li<>5) and (co<>5) then begin
                  retourne(co,li);
                end; {if}
              end; {with}
            end; {if}
          end;
      '+':if nb_coup<>0 then begin
            indique_coup(coup_choisi,c_marqueur1);
            if coup_choisi=nb_coup then coup_choisi:=1
                                   else coup_choisi:=coup_choisi+1;
            indique_coup(coup_choisi,c_marqueur2);
          end;
      '-':if nb_coup<>0 then begin
            indique_coup(coup_choisi,c_marqueur1);
            if coup_choisi=1 then coup_choisi:=nb_coup
                             else coup_choisi:=coup_choisi-1;
            indique_coup(coup_choisi,c_marqueur2);
          end;
      #13:begin
            if nb_coup<>0 then begin
              ligne:=possible[coup_choisi].li;
              colonne:=possible[coup_choisi].co;
              for k:=1 to nb_coup do indique_coup(k,' ');
            end; {if}
          end;
      end; {case}
  until (com1 in [#13,'M','P']);
end; {command}

begin {othello}
  init;
  repeat
    repeat
      repeat
        cherche_coup;
        choisi_coup;
        affiche_info;
        joue:=true;
        case mode of
          auto_blanc:if joueur=noir then command;
          auto_noir :if joueur=blanc then command;
          manuel    :command;
        end; {case}
      until joue;
      if nb_coup<>0 then begin
        passe:=0;
        retourne(colonne,ligne);
      end {if}
      else if passe<2 then begin
        passe:=passe+1;
      end ; {else if}
      joueur:=adversaire;
    until (score[vide]=0) or (passe=2);
    affiche_info;
    if mode=auto then mode:=auto_blanc;
  until false;
end.
